public class MySound extends Sound
{
  public MySound(double sec)
  {
    super(sec);
  }
  
  public MySound(int numFrames)
  {
    super(numFrames);
  }
  
  public MySound(String file)
  {
    super(file);
  }
  
  public static MySound makeSinSound(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      rawVal = Math.sin((i / sampPerCycle) * maxVal);
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound1(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = .1 * (8 * Math.sin(x) + Math.sin(6 * x) + Math.sin(4 * x));
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound2(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = 2 * (-.5 + Math.abs(Math.sin(x)));
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound3(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = 1 + (2 * (int)Math.sin(x));
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound4(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = Math.cbrt(Math.sin(x));
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound5(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = Math.sin(Math.pow(x, 1.1)) * ((i < 22050 / 6)?1:0) + Math.sin(x) * ((i >= 22050 / 6)?1:0);
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound6(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = Math.asin(x);
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound7(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = (Math.sin(500000 * Math.pow(x, -1)));
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
  
  public static MySound makeSound8(double freq, int maxAmp)
  {
    MySound s = new MySound(22050);
    double sampRate = 22050;
    double rawVal = 0;
    int val = 0;
    double interval = 1.0 / freq; // length of cycle in seconds
    double sampPerCycle = interval * sampRate;
    double maxVal = 2 * Math.PI;
    
    // Loop through the sound
    for (int i = 0; i < 22050; i++)
    {
      // Calculate the value between -1 and 1
      double x = (i / sampPerCycle) * maxVal;
      rawVal = .0001 * (Math.cosh(.5 * x) + 9999 * Math.sin(x));
      
      // Multiply by the desired max amplitude
      val = (int)(maxAmp * rawVal);
      
      // Set the value at this index
      s.setSample(i, val);
    }
    
    return s;
  }
}