/**************************************************************
 * The Play class
 * By: Shaun M. McFall
 * Under: Dr. Krone, Dr. Bressoud
 * Denison University
 * Summer, 2007
 **************************************************************/

import javax.sound.sampled.*;

public class Play extends Thread {
  // The Sound object that will be acted on
  private Sound snd = null;
  // Is the sound currently playing?
  private boolean playing = false;
  // The Clip object that will actually play
  private Clip clip = null;
  // The length and position
  int len, pos;
  
  // The constructor takes a sound to be played
  //  and turns it into a clip
  public Play(Sound sound) {
    snd = sound;
    // Create the clip
    AudioInputStream ais = sound.makeAIS();
    DataLine.Info info = new DataLine.Info(Clip.class, ais.getFormat());
    try {
      clip = (Clip) AudioSystem.getLine(info);
      clip.open(ais);
    } catch (Exception e) {
      System.out.println("Error playing file!");
      return;
    }
    len = clip.getFrameLength();
    pos = 0;
  }
  
  public void run() {
    playing = true;
    boolean done = false;
    clip.start();
    pos = clip.getFramePosition();
    while (pos < len) {
      pos = clip.getFramePosition();
      if (pos > 0)
        done = true;
      if (done) {
        if (pos == 0)
          break;
      }
    }
    len = 0; pos = 0;
    playing = false;
    clip.stop();
    clip.close();
    clip = null;
  }
  
  public boolean isPlaying() {
    return playing;
  }
  
  public int getLeft() {
    return len - pos;
  }
  
  public void stopPlay() {
    playing = false;
  }
}